const kDebug = true;
var debug;
if (!kDebug)
  debug = function(m) {};
else
  debug = function(m) { dump("\t @@@ " + m + "\n"); };

const nsIAppShellService = Components.interfaces.nsIAppShellService;
const nsIProfileInternal = Components.interfaces.nsIProfileInternal;
const nsIPrefBranch = Components.interfaces.nsIPrefBranch;

function licenseAccept()
{
  debug("licenseAccept");
  
  // switch the license-accepted pref to true
  var prefs = Components.classes["@mozilla.org/preferences;1"].
    getService(nsIPrefBranch);
  prefs.setBoolPref("general.license.accepted", true);
}

function licenseDecline()
{
  debug("licenseDecline");
  
  var profileManager = Components.classes["@mozilla.org/profile/manager;1"].
    getService(nsIProfileInternal);
  // Cause a failed rv so the app won't startup; necessary in
  // addition to telling the app shell service to quit.
  // See InitalizeProfileService() in nsAppRunner.cpp.
  profileManager.forgetCurrentProfile(); 

  var appShellService = Components.
    classes["@mozilla.org/appshell/appShellService;1"].
    getService(nsIAppShellService);
  appShellService.Quit();
} 
